## source all necessary functions  -- remove these source lines before packaging
#source('CatCall.R')
#source('CatCover.R')
#source('Smooth.r')
#source('AutoCorr.r')
#source('Actogram.r')
#source('CrossCorr.R')


#source('Import5.R')
#source('CatPeri.R')  
#source('CatWindow.R')
#source('CatBin.R')

library("CATkit")
library("signal")   #importFrom(foo, f, g)  in R namespace
library("rtf")
library("png")
library("grid")
library("season")


##First read in the arguments listed at the command line
# arguments must have no spaces, as it is space delimited
args=(commandArgs(TRUE))
# substitute in spaces for each underscore.
sub(pattern="_",x=args,replacement=" ",fixed=TRUE)

##args is now a list of character vectors
## First check to see if arguments are passed.
## Then cycle through each element of the list and evaluate the expressions.

## Default setting when no arguments passed
if(length(args) < 1) {
  args <- c("--help")
}

## Help section
if("--help" %in% args) {
  cat('
      The R Script
      
      Arguments:
      "--args startX=5 endX=6 lum=4 export=F sizePts=2 binPts=5 Span=0 Increment=0 k=6 yLab=\'Activity_Levels\'"
      Any string parameter should have no spaces, but "_" where spaces should be
      A string parameter should be in single quotes
      
      if --args is empty, or contains "--help", this text will be printed 
      
      Example:
      c:\\my\\path\\bin\\R.exe CMD BATCH  --slave --vanilla "--args func='CatCall' a b c" script.r outfile.txt \n\n')
  
  q(save="no")
}


  for(i in 1:length(args)){
    eval(parse(text=args[[i]]))
    
  }

#print(yLab)
#source('CatCall.r')

if (func=='CatCall'){
  CatCall(startX=startX, endX=endX, lum=lum, export=export, sizePts=sizePts, binPts=binPts, Span = Span, Increment=Increment, k=k, yLab=yLab, modulo=modulo,Rverbose=Rverbose, RmaxGap=RmaxGap, Skip=Skip,nFiles=nFiles, Smoothing=Smoothing, Actogram=Actogram,AutoCorr=AutoCorr,CrossCorr=CrossCorr,Console=Console,Graphics=Graphics, Darkness1=Darkness1,Darkness2=Darkness2,LagPcnt=LagPcnt)
} else if (func=='Cosinor'){
  CosinorSpan_PeriVsCosFiltCATmulti3varsProg(call=TRUE)
}
